<?php

/**
 * Generates a popular posts list from shortcode
 *
 * @access public
 * @param mixed $atts
 * @return void
 */
function nnr_popular_posts_shortcode($atts) {

	$args = shortcode_atts( array(
		'id'							=> 'nnrobots_popular_posts_0',
        'content'                       => 'only_posts',
        'content_post_category'         => '',
        'content_post_tag'              => '',
        'content_custom_post_type'      => '',
        'popularity'                    => 'views',
        'popularity_time_range'         => 'all_time',
        'layout'                        => 'list',
        'numbered_list_style'           => 'normal',
        'numbered_list_color'           => '#FFFFFF',
        'numbered_list_circle_color'    => '#94CD4B',
        'grid_size'                     => 'medium',
        'show_views'					=> true,
        'show_comments'					=> true,
        'show_nav'						=> true,
        'show_category'                 => true,
        'show_author'                   => true,
        'show_post_date'                => true,
        'color'                         => '#D3D3D3',
        'text_color'                    => '#000000',
        'fancy_colors'                  => '#D14841,#F37934,#FAC51C,#61BD6D,#2C82C9,#553982',
        'num_of_posts'                  => '5',
        'async'                         => false,
        'style_override'                => true,
    ), $atts );

    // Do not display shortcode if the post is displayed within a loop

    if (!is_singular()) {
		return null;
    }

    if (isset($args['show_views']) && $args['show_views'] == 'true') {
	    $args['show_views'] = true;
    } else {
	    $args['show_views'] = false;
    }

    if (isset($args['show_comments']) && $args['show_comments'] == 'true') {
	    $args['show_comments'] = true;
    } else {
	    $args['show_comments'] = false;
    }

    if (isset($args['show_category']) && $args['show_category'] == 'true') {
	    $args['show_category'] = true;
    } else {
	    $args['show_category'] = false;
    }

    if (isset($args['show_author']) && $args['show_author'] == 'true') {
	    $args['show_author'] = true;
    } else {
	    $args['show_author'] = false;
    }

    if (isset($args['show_post_date']) && $args['show_post_date'] == 'true') {
	    $args['show_post_date'] = true;
    } else {
	    $args['show_post_date'] = false;
    }

    // Format data

    $args['content_custom_post_type'] = explode(',', $args['content_custom_post_type']);

	list($r, $g, $b)                               = sscanf($args['color'], "#%02x%02x%02x");
	list($text_r, $text_g, $text_b)                = sscanf($args['text_color'], "#%02x%02x%02x");
	list($nl_r, $nl_g, $nl_b)                      = sscanf($args['numbered_list_color'], "#%02x%02x%02x");
	list($nl_circle_r, $nl_circle_g, $nl_circle_b) = sscanf($args['numbered_list_circle_color'], "#%02x%02x%02x");

	$content = '';

	if (isset($args['async']) && $args['async'] == 'true') {
		$content = '<script type="text/javascript">
		jQuery(document).ready(function($) {

			var data = {
				"action": "nnr_display_popular_posts",
				"instance" : ' . json_encode($args) . ',
				"widget_id" : "' . $args['id'] . '",
				"shortcode": true,
			};

			$.post("' . admin_url( 'admin-ajax.php' ) . '", data, function(response) {
				var data = jQuery.parseJSON(response);
				$("#" + data.widget_id).append(data.content).hide().fadeIn();';

					if ($args['layout'] == 'masonry') {
						$content .= '$("#" + data.widget_id .' . NNRobots_Popular_Posts::$prefix_dash . 'masonry").justifiedGallery({
							lastRow: "justify",
							rowHeight: 150,
						});';
					}

					if ($args['layout'] == 'slider') {
						$content .= '$("#" + data.widget_id .' . NNRobots_Popular_Posts::$prefix_dash . 'slider").flexslider({
							animation: "fade",';

						if (isset($args[ 'show_nav' ]) && $args[ 'show_nav' ]) {
							$content .= 'directionNav: true,';
						} else {
							$content .= 'directionNav: false,';
						}

						$content .= '});';
					}

			$content .= '});
		});
		</script>
		<div id="' . $args['id'] . '" class="' . NNRobots_Popular_Posts::$prefix_dash . 'shortcode"></div>';
	} else {
		$content = '<script type="text/javascript">
			jQuery(document).ready(function($) {';

				if ($args['layout'] == 'masonry') {
					$content .= '$("#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'masonry").justifiedGallery({
						lastRow: "justify",
						rowHeight: 150,
					});';
				}

				if ($args['layout'] == 'slider') {
					$content .= '$("#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'slider").flexslider({
						animation: "fade",';

					if (isset($args[ 'show_nav' ]) && $args[ 'show_nav' ]) {
						$content .= 'directionNav: true,';
					} else {
						$content .= 'directionNav: false,';
					}

					$content .= '});';
				}

			$content .= ';});
		</script>';
		$content .= NNRobots_Popular_Posts_Widget::display_popular_posts($args, true);
	}

	if ($args['style_override'] == 'true') {

		$content .= '<style>

			/* Background Color */

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'bar-graph .' . NNRobots_Popular_Posts::$prefix_dash . 'bar-graph-color {
				background-color: rgba(' . $r. ', ' . $g. ', ' . $b. ', 0.5);
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'line-graph .' . NNRobots_Popular_Posts::$prefix_dash . 'line-graph-color {
				background-color: rgba(' . $r. ', ' . $g. ', ' . $b. ', 1);
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'image-tile-item {
				background-color: rgba(' . $r. ', ' . $g. ', ' . $b. ', 0.8);
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'image-tile-item .' . NNRobots_Popular_Posts::$prefix_dash . 'title {
				background-color: rgba(' . $r. ', ' . $g. ', ' . $b. ', 0.9);
			}

			/* Text Color */

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'list li a {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'list li span {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'thumbnail li a {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'thumbnail li span {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'bar-graph-color a {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'bar-graph-color span {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'line-graph-content a {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'line-graph-content span {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'image-tile-item .' . NNRobots_Popular_Posts::$prefix_dash . 'title {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'image-tile-data * {
				color: rgb(' . $text_r. ', ' . $text_g. ', ' . $text_b. ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'fancy-colors-content a {
				color: rgb(' . $text_r . ', ' . $text_g . ', ' . $text_b . ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'fancy-colors-content span {
				color: rgb(' . $text_r . ', ' . $text_g . ', ' . $text_b . ');
			}

			/* Numbered List */

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'numbered-list-big li > div:first-of-type:before {
				color: rgb(' . $nl_r . ', ' . $nl_g . ', ' . $nl_b . ');
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'numbered-list-circle li > div:first-of-type:before {
				color: rgb(' . $nl_r . ', ' . $nl_g . ', ' . $nl_b . ');
				background-color: rgb(' . $nl_circle_r . ', ' . $nl_circle_g . ', ' . $nl_circle_b . ');
			}

		</style>';
	} else {
		$content .= '<style>

			/* Background Color */

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'bar-graph .' . NNRobots_Popular_Posts::$prefix_dash . 'bar-graph-color {
				background-color: rgba(190, 190, 190, 0.5);
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'line-graph .' . NNRobots_Popular_Posts::$prefix_dash . 'linep-graph-color {
				background-color: rgba(0, 0, 0, 1);
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'image-tile-item {
				background-color: rgba(0, 0, 0, 0.8);
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'image-tiles .' . NNRobots_Popular_Posts::$prefix_dash . 'title {
				background-color: rgba(0, 0, 0, 0.9);
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'image-tiles .' . NNRobots_Popular_Posts::$prefix_dash . 'title {
				color: white;
			}

			#' . $args['id'] . ' .' . NNRobots_Popular_Posts::$prefix_dash . 'image-tile-data * {
				color: white;
			}

		</style>';
	}

	// Include masonry files

	if ($args['layout'] == 'masonry') {
		wp_enqueue_script(NNRobots_Popular_Posts::$prefix_dash . 'justified_gallery_js', plugins_url('core/includes/masonry/jquery.justifiedGallery.min.js', __FILE__), array('jquery'));
		wp_enqueue_style(NNRobots_Popular_Posts::$prefix_dash . 'justified_gallery_css', plugins_url('core/includes/masonry/justifiedGallery.min.css', __FILE__));
	}

	// Include slider files

	if ($args['layout'] == 'slider') {
		wp_enqueue_script(NNRobots_Popular_Posts::$prefix_dash . 'slider_js', plugins_url('core/includes/flex-slider/jquery.flexslider-min.js', __FILE__), array('jquery'));
		wp_enqueue_style(NNRobots_Popular_Posts::$prefix_dash . 'slider_css', plugins_url('core/includes/flex-slider/flexslider.css', __FILE__));
	}

	wp_enqueue_style(NNRobots_Popular_Posts::$prefix_dash . 'widget_css', plugins_url('core/css/nnr-popular-posts.css', __FILE__));

	return $content;
}